/**
 * \file pid.cpp
 * \brief 简要介绍
 * \details 详细说明
 * \author lenotary
 * \version 1.0
 * \date 2021/9/13
 * \pre 先决条件。（有的话才添加。）
 * \bug 存在的bug。（有的话才添加，注明“还未发现”也可以。）
 * \warning 警告。（有的话才添加。）
 * \copyright 版权声明。（通常只写遵循什么协议，版权详细内容应放在LICENSE文件中，并且应该与LICENSE文件的内容统一，不能自相矛盾。）
 * \since 一些历史情况记录。（有的话才添加。）
 */

//
// Created by lenotary on 2021/9/13.
//

#include "pid.h"

Pid::Pid(double kp, double ki, double kd, double iMax, double outMax) {
    m_fKp_ = kp;
    m_fKi_ = ki;
    m_fKd_ = kd;
    m_fInMax_ = iMax;
    m_fOutMax = outMax;
}

double Pid::PidCalc(int ref, int fdb) {
    m_dRef_ = ref;
    m_dFdb_ = fdb;
    m_dErr_[1] = m_dErr_[0];
    m_dErr_[0] = ref - fdb;
    m_dPOut_ = m_fKp_ * m_dErr_[0];

    m_dIOut_ += m_fKi_ * m_dErr_[0];
    m_dDOut_ = m_fKd_ * (m_dErr_[0] - m_dErr_[1]);
    LIMIT_MIN_MAX(m_dIOut_, -m_fInMax_, m_fInMax_);
    m_DOutput_ = m_dPOut_ + m_dIOut_ + m_dDOut_;
    LIMIT_MIN_MAX(m_DOutput_, -m_fOutMax, m_fOutMax);

    return m_DOutput_;
}

